var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { Sdk } from "./sdk";
import { NullStore } from "../store/nullStore";
import { CookiesStore } from "../store/cookiesStore";
import { MemoryStore } from "../store/memoryStore";
import { EventQueueImpl } from "../transport/queue";
import { UserImpl } from "../domain/user";
import { EventFactoryImpl } from "../transport/eventFactory";
import { ContextFactoryImpl } from "../transport/context";
import { OperationsPriorityQueueImpl } from "../lib/priorityQueue";
import { GroupFactoryImpl } from "../domain/group";
import { SESSION_ID_PERSISTENCE_KEY, StoresGroup } from "../store/store";
import { BrowserStore } from "../store/browserStore";
import { FacebookPixel } from "../transport/plugins/facebook/facebookPixel";
import { SnapchatPixel } from "../transport/plugins/snapchat/snapchatPixel";
import { BrowserImpl, UTM_KEYS } from "../transport/browser";
import { GA4Pixel } from "../transport/plugins/ga4_pixel/ga4PPixel";
import { TikTokPixel } from "../transport/plugins/tiktok/tiktokPixel";
import { CleverTapPlugin } from "../transport/plugins/cleverTap/cleverTapPlugin";
import { CleverTapWrapperImpl } from "../transport/plugins/cleverTap/cleverTapWrapper";
import { EventMapperFactoryImpl, FieldsMapperFactoryImpl, } from "../transport/plugins/lib/mapping";
import { SessionStore } from "../store/sessionStore";
import { ExternalIdsSessionCacheImpl } from "../domain/externalId";
import { AutoCapturePII } from "../lib/autoCapturePII";
import { HttpCookieServiceImpl } from "../lib/httpCookieService";
import { PinterestTag } from "../transport/plugins/pinterest/pinterestTag";
import { JournifyioPlugin } from "../transport/plugins/journifyio/journifyio";
import { XPixel } from "../transport/plugins/x/xPixel";
import { BingAdsTag } from "../transport/plugins/bing_ads_tag/bing_ads_tag";
import { GoogleAdsGtag } from "../transport/plugins/google_ads_gtag/googleAdsGtag";
import { LinkedinAdsInsightTag } from "../transport/plugins/linkedin_ads_insight_tag/linkedinAdsInsightTag";
var INTEGRATION_PLUGINS = {
    bing_ads_tag: BingAdsTag,
    clevertap: CleverTapPlugin,
    facebook_pixel: FacebookPixel,
    ga4_pixel: GA4Pixel,
    google_ads_gtag: GoogleAdsGtag,
    linkedin_ads_insight_tag: LinkedinAdsInsightTag,
    pinterest_tag: PinterestTag,
    snapchat_pixel: SnapchatPixel,
    tiktok_pixel: TikTokPixel,
    x_pixel: XPixel,
};
var JOURNIFY_PREFIX = "[Journify]";
var Loader = /** @class */ (function () {
    function Loader(sentryWrapper) {
        this.sdk = null;
        this.user = null;
        this.plugins = {};
        this.sessionIntervalId = null;
        this.stores = null;
        this.cookiesStore = null;
        this.sentryWrapper = sentryWrapper;
    }
    Loader.prototype.load = function (sdkConfig, writeKeySettings) {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter(this, void 0, void 0, function () {
            var browser, cookieService;
            return __generator(this, function (_g) {
                switch (_g.label) {
                    case 0:
                        this.sdkSettings = sdkConfig;
                        this.writeKeySettings = writeKeySettings;
                        this.startNewSession();
                        browser = new BrowserImpl();
                        if ((_b = (_a = this.sdkSettings) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.httpCookieServiceOptions) {
                            cookieService = new HttpCookieServiceImpl((_d = (_c = this.sdkSettings) === null || _c === void 0 ? void 0 : _c.options) === null || _d === void 0 ? void 0 : _d.httpCookieServiceOptions, browser, this.sentryWrapper, this.cookiesStore);
                        }
                        this.user = new UserImpl(this.stores, this.sentryWrapper, cookieService, (_f = (_e = this.sdkSettings) === null || _e === void 0 ? void 0 : _e.options) === null || _f === void 0 ? void 0 : _f.phoneCountryCode);
                        return [4 /*yield*/, this.user.load()];
                    case 1:
                        _g.sent();
                        if (!this.sdk) {
                            this.initSdk();
                        }
                        else {
                            this.updatePluginSettings();
                        }
                        return [2 /*return*/, this.sdk];
                }
            });
        });
    };
    Loader.prototype.initSdk = function () {
        var _a, _b, _c;
        var fieldMapperFactory = new FieldsMapperFactoryImpl();
        var browser = new BrowserImpl();
        var logger = {
            log: function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return console.log.apply(console, __spreadArray([JOURNIFY_PREFIX], args, false));
            },
        };
        var testingMode = isTestingWriteKey(this.sdkSettings.writeKey);
        var pluginExternalSDKs = {
            clevertap: new CleverTapWrapperImpl(browser, logger, testingMode),
        };
        this.plugins = {
            journifyio: new JournifyioPlugin(this.sdkSettings, this.sentryWrapper),
        };
        for (var _i = 0, _d = this.writeKeySettings.syncs; _i < _d.length; _i++) {
            var sync = _d[_i];
            var plugin = INTEGRATION_PLUGINS[sync.destination_app];
            if (plugin) {
                var pluginDeps = {
                    user: this.user,
                    fieldMapperFactory: fieldMapperFactory,
                    eventMapperFactory: new EventMapperFactoryImpl(),
                    browser: browser,
                    sync: sync,
                    testingWriteKey: testingMode,
                    externalSDK: pluginExternalSDKs[sync.destination_app],
                    enableHashing: (_b = (_a = this.sdkSettings) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.enableHashing,
                    logger: logger,
                    sentry: this.sentryWrapper,
                };
                this.plugins[sync.id] = new plugin(pluginDeps);
            }
        }
        var pQueue = new OperationsPriorityQueueImpl(DEFAULT_MAX_QUEUE_ATTEMPTS);
        var sessionStore = new SessionStore(browser);
        var externalIdsSessionCache = new ExternalIdsSessionCacheImpl(browser, sessionStore);
        var deps = {
            user: this.user,
            eventFactory: new EventFactoryImpl(this.stores, this.cookiesStore, browser, externalIdsSessionCache),
            groupFactory: new GroupFactoryImpl(this.stores),
            contextFactory: new ContextFactoryImpl(),
            eventQueue: new EventQueueImpl(Object.values(this.plugins), pQueue, browser, this.sentryWrapper),
        };
        this.sdk = new Sdk(this.sdkSettings, deps);
        if ((_c = this.sdkSettings.options) === null || _c === void 0 ? void 0 : _c.autoCapturePII) {
            var autoCapturePII = new AutoCapturePII(browser, this.user, this.sdkSettings.options.autoCapturePhoneRegex);
            autoCapturePII.listen();
        }
    };
    Loader.prototype.updatePluginSettings = function () {
        var syncsMap = {};
        for (var _i = 0, _a = this.writeKeySettings.syncs; _i < _a.length; _i++) {
            var sync = _a[_i];
            syncsMap[sync.id] = sync;
        }
        for (var syncID in this.plugins) {
            var settings = syncsMap[syncID];
            if (!settings) {
                settings = this.sdkSettings;
            }
            var plugin = this.plugins[syncID];
            plugin.updateSettings(settings);
        }
    };
    Loader.prototype.initStores = function () {
        var _a, _b, _c;
        if (this.stores) {
            return;
        }
        var localStore = new BrowserStore(BrowserStore.isLocalStorageAvailable() ? localStorage : undefined);
        var memoryStore = new MemoryStore();
        var cookiesStore = CookiesStore.isAvailable()
            ? new CookiesStore((_c = (_b = (_a = this.sdkSettings) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.cookie) === null || _c === void 0 ? void 0 : _c.domain)
            : new NullStore();
        this.stores = new StoresGroup(localStore, cookiesStore, memoryStore);
        this.cookiesStore = cookiesStore;
    };
    Loader.prototype.startNewSession = function () {
        var _this = this;
        var _a, _b;
        this.initStores();
        if (this.sessionIntervalId) {
            clearInterval(this.sessionIntervalId);
        }
        var currentEpoch = new Date().getTime();
        if (!this.stores.get(SESSION_ID_PERSISTENCE_KEY)) {
            this.stores.set(SESSION_ID_PERSISTENCE_KEY, currentEpoch);
            var sessionDurationMin = ((_b = (_a = this.sdkSettings) === null || _a === void 0 ? void 0 : _a.options) === null || _b === void 0 ? void 0 : _b.sessionDurationMin) ||
                DEFAULT_SESSION_DURATION_MIN;
            this.sessionIntervalId = setInterval(function () {
                var newSessionId = new Date().getTime();
                _this.stores.set(SESSION_ID_PERSISTENCE_KEY, newSessionId);
                _this.resetUtmCampaign();
            }, sessionDurationMin * 60 * 1000);
        }
    };
    Loader.prototype.resetUtmCampaign = function () {
        var _this = this;
        UTM_KEYS.forEach(function (key) { return _this.stores.remove(key[0]); });
    };
    return Loader;
}());
export { Loader };
var WRITE_KEY_TEST_PREFIX = "wk_test_";
var WRITE_KEY_PROD_PREFIX = "wk_";
function isTestingWriteKey(writeKey) {
    return writeKey === null || writeKey === void 0 ? void 0 : writeKey.startsWith(WRITE_KEY_TEST_PREFIX);
}
export function getProductionWriteKey(writeKey) {
    if (isTestingWriteKey(writeKey)) {
        return writeKey === null || writeKey === void 0 ? void 0 : writeKey.replace(WRITE_KEY_TEST_PREFIX, WRITE_KEY_PROD_PREFIX);
    }
    return writeKey;
}
var DEFAULT_MAX_QUEUE_ATTEMPTS = 2;
var DEFAULT_SESSION_DURATION_MIN = 30;
//# sourceMappingURL=loader.js.map