var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var ExternalIdsSessionCacheImpl = /** @class */ (function () {
    function ExternalIdsSessionCacheImpl(browser, sessionStorage) {
        this.sessionStorage = sessionStorage;
        this.browser = browser;
        this.initIds();
    }
    ExternalIdsSessionCacheImpl.prototype.getExternalIds = function () {
        var urlParams = new URLSearchParams(this.browser.location().search);
        var potentialIds = {
            snapchat_click_id: urlParams.get("ScCid"),
            tiktok_click_id: urlParams.get("ttclid"),
            twitter_click_id: urlParams.get("twclid"),
            google_click_id: urlParams.get("gclid"),
            google_wbraid: urlParams.get("wbraid"),
            google_gbraid: urlParams.get("gbraid"),
            pinterest_click_id: urlParams.get("epik"),
            microsoft_click_id: urlParams.get("msclkid"),
            linkedin_click_id: urlParams.get("li_fat_id"),
        };
        var currentIds = Object.entries(potentialIds).reduce(function (accumulator, _a) {
            var key = _a[0], value = _a[1];
            if (value) {
                accumulator[key] = value;
            }
            return accumulator;
        }, {});
        var storedIds = this.sessionStorage.get(EXTERNAL_IDS_SESSION_STORAGE_KEY) || {};
        return __assign(__assign({}, storedIds), currentIds);
    };
    ExternalIdsSessionCacheImpl.prototype.initIds = function () {
        var ids = this.getExternalIds();
        this.sessionStorage.set(EXTERNAL_IDS_SESSION_STORAGE_KEY, ids);
    };
    return ExternalIdsSessionCacheImpl;
}());
export { ExternalIdsSessionCacheImpl };
var EXTERNAL_IDS_SESSION_STORAGE_KEY = "journifyio_external_ids";
//# sourceMappingURL=externalId.js.map