var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { GROUP_TRAITS_PERSISTENCE_KEY } from "./traits";
var GROUP_ID_PERSISTENCE_KEY = "journifyio_group_id";
var GroupFactoryImpl = /** @class */ (function () {
    function GroupFactoryImpl(stores) {
        this.stores = stores;
    }
    GroupFactoryImpl.prototype.loadGroup = function () {
        return new GroupImpl(this.stores);
    };
    return GroupFactoryImpl;
}());
export { GroupFactoryImpl };
var GroupImpl = /** @class */ (function () {
    function GroupImpl(stores) {
        this.traits = {};
        this.stores = stores;
        this.initGroupId();
        this.initTraits();
    }
    GroupImpl.prototype.identify = function (groupId, traits) {
        if (traits === void 0) { traits = {}; }
        if (groupId) {
            this.setGroupId(groupId);
        }
        var newTraits = __assign(__assign({}, this.getTraits()), traits);
        this.setTraits(newTraits);
    };
    GroupImpl.prototype.getGroupId = function () {
        return this.groupId;
    };
    GroupImpl.prototype.getTraits = function () {
        return this.traits;
    };
    GroupImpl.prototype.initGroupId = function () {
        this.groupId = this.stores.get(GROUP_ID_PERSISTENCE_KEY);
        if (this.groupId) {
            this.stores.set(GROUP_ID_PERSISTENCE_KEY, this.groupId);
        }
    };
    GroupImpl.prototype.initTraits = function () {
        var traits = this.stores.get(GROUP_TRAITS_PERSISTENCE_KEY);
        this.setTraits(traits);
    };
    GroupImpl.prototype.setTraits = function (newTraits) {
        var traits = __assign(__assign({}, this.traits), (newTraits !== null && newTraits !== void 0 ? newTraits : {}));
        this.stores.set(GROUP_TRAITS_PERSISTENCE_KEY, traits);
    };
    GroupImpl.prototype.setGroupId = function (groupId) {
        this.groupId = groupId;
        this.stores.set(GROUP_ID_PERSISTENCE_KEY, groupId);
    };
    return GroupImpl;
}());
//# sourceMappingURL=group.js.map