var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { v4 as uuid } from "uuid";
import { USER_TRAITS_PERSISTENCE_KEY } from "./traits";
import { normalizePhone, parseNumberToString } from "../lib/utils";
var ANONYMOUS_ID_PERSISTENCE_KEY = "journifyio_anonymous_id";
var USER_ID_PERSISTENCE_KEY = "journifyio_user_id";
var EXTERNAL_IDs_PERSISTENCE_KEY = "journifyio_external_ids";
var UserImpl = /** @class */ (function () {
    function UserImpl(stores, sentry, cookiesService, phoneCountryCode) {
        this.traits = {};
        this.stores = stores;
        this.sentry = sentry;
        this.cookieService = cookiesService;
        this.phoneCountryCode = phoneCountryCode;
    }
    UserImpl.prototype.load = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.initAnonymousId()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.initUserId()];
                    case 2:
                        _a.sent();
                        this.initTraits();
                        this.initExternalIds();
                        return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.identify = function (userId, traits, externalIds) {
        if (traits === void 0) { traits = {}; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!(userId && userId != this.userId)) return [3 /*break*/, 3];
                        if (this.userId) {
                            this.clearUserData();
                        }
                        return [4 /*yield*/, this.setUserId(userId)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.syncAndSetServerCookies()];
                    case 2:
                        _a.sent();
                        _a.label = 3;
                    case 3: return [4 /*yield*/, this.setTraits(traits)];
                    case 4:
                        _a.sent();
                        if (!externalIds) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.setExternalIds(externalIds)];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.getUserId = function () {
        return this.userId;
    };
    UserImpl.prototype.getAnonymousId = function () {
        return this.anonymousId;
    };
    UserImpl.prototype.getTraits = function () {
        return this.traits;
    };
    UserImpl.prototype.getExternalIds = function () {
        return this.externalIds;
    };
    UserImpl.prototype.syncAndSetServerCookies = function () {
        return __awaiter(this, void 0, void 0, function () {
            var httpCookies, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        if (!this.cookieService)
                            return [2 /*return*/];
                        return [4 /*yield*/, this.cookieService.dispatchRenew()];
                    case 1:
                        httpCookies = _a.sent();
                        if (httpCookies.anonymousId) {
                            this.anonymousId = httpCookies.anonymousId;
                            this.stores.set(ANONYMOUS_ID_PERSISTENCE_KEY, this.anonymousId);
                        }
                        if (httpCookies.userId) {
                            this.userId = httpCookies.userId;
                            this.stores.set(USER_ID_PERSISTENCE_KEY, this.userId);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        this.sentry.captureException(err_1);
                        console.error(err_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.clearUserData = function () {
        this.anonymousId = null;
        this.userId = null;
        this.externalIds = null;
        this.traits = null;
        this.stores.remove(ANONYMOUS_ID_PERSISTENCE_KEY);
        this.stores.remove(USER_ID_PERSISTENCE_KEY);
        this.stores.remove(EXTERNAL_IDs_PERSISTENCE_KEY);
        this.stores.remove(USER_TRAITS_PERSISTENCE_KEY);
    };
    UserImpl.prototype.initUserId = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.userId = this.stores.get(USER_ID_PERSISTENCE_KEY);
                        if (!this.userId) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.setUserId(this.userId)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.initAnonymousId = function () {
        return __awaiter(this, void 0, void 0, function () {
            var newlyGenerated;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.anonymousId = this.stores.get(ANONYMOUS_ID_PERSISTENCE_KEY);
                        newlyGenerated = false;
                        if (!this.anonymousId) {
                            this.anonymousId = uuid();
                            newlyGenerated = true;
                        }
                        this.stores.set(ANONYMOUS_ID_PERSISTENCE_KEY, this.anonymousId);
                        if (!newlyGenerated) return [3 /*break*/, 2];
                        // Only when anonymousId is generated, sync with server cookies
                        return [4 /*yield*/, this.syncAndSetServerCookies()];
                    case 1:
                        // Only when anonymousId is generated, sync with server cookies
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.initExternalIds = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        // get externalIds from one of the stores
                        this.externalIds = this.stores.get(EXTERNAL_IDs_PERSISTENCE_KEY);
                        if (!this.externalIds) return [3 /*break*/, 2];
                        // set externalIds on all stores
                        return [4 /*yield*/, this.setExternalIds(this.externalIds)];
                    case 1:
                        // set externalIds on all stores
                        _a.sent();
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.initTraits = function () {
        return __awaiter(this, void 0, void 0, function () {
            var traits;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        traits = this.stores.get(USER_TRAITS_PERSISTENCE_KEY);
                        return [4 /*yield*/, this.setTraits(traits)];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    UserImpl.prototype.setTraits = function (newTraits) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.traits = __assign(__assign({}, this.traits), newTraits);
                this.formatPhone();
                this.stores.set(USER_TRAITS_PERSISTENCE_KEY, this.traits);
                return [2 /*return*/];
            });
        });
    };
    UserImpl.prototype.formatPhone = function () {
        var _a, _b;
        if (((_a = this.phoneCountryCode) === null || _a === void 0 ? void 0 : _a.length) > 0 && ((_b = this.traits.phone) === null || _b === void 0 ? void 0 : _b.length) > 0) {
            this.traits.phone = normalizePhone(this.traits.phone, this.phoneCountryCode);
        }
    };
    UserImpl.prototype.setUserId = function (userId) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.userId = parseNumberToString(userId);
                this.stores.set(USER_ID_PERSISTENCE_KEY, this.userId);
                return [2 /*return*/];
            });
        });
    };
    UserImpl.prototype.setExternalIds = function (externalIds) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                this.externalIds = externalIds;
                this.stores.set(EXTERNAL_IDs_PERSISTENCE_KEY, externalIds);
                return [2 /*return*/];
            });
        });
    };
    return UserImpl;
}());
export { UserImpl };
//# sourceMappingURL=user.js.map