var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { getProductionWriteKey, Loader } from "./api/loader";
import { SentryWrapperImpl } from "./lib/sentry";
import { removeEmptyStrings } from "./lib/utils";
var DEFAULT_CDN_HOST = "https://static.journify.io";
var callsBeforeLoad = [];
var sentryWrapper = new SentryWrapperImpl();
var loader = new Loader(sentryWrapper);
var sdk = null;
var recordingCallsBeforeLoad = false;
function load(sdkSettings) {
    return __awaiter(this, void 0, void 0, function () {
        var wKeySettings, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, fetchWriteKeySettings(sdkSettings)];
                case 1:
                    wKeySettings = _a.sent();
                    return [4 /*yield*/, loader.load(sdkSettings, wKeySettings)];
                case 2:
                    sdk = _a.sent();
                    callsBeforeLoad.forEach(function (call) { return call(); });
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    sentryWrapper.captureException(error_1);
                    console.error(error_1);
                    return [3 /*break*/, 4];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function fetchWriteKeySettings(sdkSettings) {
    return __awaiter(this, void 0, void 0, function () {
        var productionWriteKey, settings;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    productionWriteKey = getProductionWriteKey(sdkSettings === null || sdkSettings === void 0 ? void 0 : sdkSettings.writeKey);
                    return [4 /*yield*/, fetchRemoteWriteKeySettings(productionWriteKey, sdkSettings.cdnHost || DEFAULT_CDN_HOST)];
                case 1:
                    settings = _a.sent();
                    if (!settings) {
                        settings = {
                            syncs: [],
                        };
                    }
                    return [2 /*return*/, settings];
            }
        });
    });
}
function fetchRemoteWriteKeySettings(writeKey, cdnHost) {
    return __awaiter(this, void 0, void 0, function () {
        var max_retries, settingsURL, i, response, settings, error, _a, _b, error_2;
        var _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    max_retries = 2;
                    settingsURL = "".concat(cdnHost, "/write_keys/").concat(writeKey, ".json");
                    i = 0;
                    _d.label = 1;
                case 1:
                    if (!(i < max_retries)) return [3 /*break*/, 14];
                    _d.label = 2;
                case 2:
                    _d.trys.push([2, 12, , 13]);
                    sentryWrapper.setTag("settingsURL", settingsURL);
                    return [4 /*yield*/, fetch(settingsURL)];
                case 3:
                    response = _d.sent();
                    if (!(200 <= response.status && response.status <= 299)) return [3 /*break*/, 5];
                    return [4 /*yield*/, response.json()];
                case 4:
                    settings = _d.sent();
                    return [2 /*return*/, settings];
                case 5:
                    if (!(500 <= response.status && response.status <= 599)) return [3 /*break*/, 8];
                    if (!(i < max_retries - 1)) return [3 /*break*/, 7];
                    console.log("Retrying in 2 seconds...");
                    return [4 /*yield*/, sleep(2000)];
                case 6:
                    _d.sent();
                    _d.label = 7;
                case 7: return [3 /*break*/, 11];
                case 8:
                    if (!(response.status != 404)) return [3 /*break*/, 11];
                    error = new Error("write key settings are not found for write key ".concat(writeKey, ". Status: ").concat(response.status));
                    _b = (_a = sentryWrapper).setResponse;
                    _c = {
                        url: settingsURL,
                        headers: response.headers,
                        status: response.status
                    };
                    return [4 /*yield*/, response.text()];
                case 9: return [4 /*yield*/, _b.apply(_a, [(_c.body = _d.sent(),
                            _c)])];
                case 10:
                    _d.sent();
                    sentryWrapper.captureException(error);
                    console.error(error);
                    _d.label = 11;
                case 11: return [2 /*return*/, { syncs: [] }];
                case 12:
                    error_2 = _d.sent();
                    sentryWrapper.captureException(error_2);
                    console.error("Failed to fetch write key settings from ".concat(settingsURL, ". error: ").concat(error_2));
                    return [3 /*break*/, 13];
                case 13:
                    i++;
                    return [3 /*break*/, 1];
                case 14: return [2 /*return*/, null];
            }
        });
    });
}
function sleep(ms) {
    return new Promise(function (resolve) { return setTimeout(resolve, ms); });
}
function identify(userId, traits, externalIds) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            try {
                if (!sdk) {
                    recordCallBeforeLoad(function () { return identify(userId, traits, externalIds); });
                    return [2 /*return*/, null];
                }
                if (!userId) {
                    throw new Error("the user id is required when calling identify");
                }
                traits = removeEmptyStrings(traits);
                loader.startNewSession();
                return [2 /*return*/, sdk.identify(userId, traits, externalIds)];
            }
            catch (error) {
                sentryWrapper.captureException(error);
                console.error(error);
            }
            return [2 /*return*/];
        });
    });
}
function track(eventName, properties, traits) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            try {
                if (!sdk) {
                    recordCallBeforeLoad(function () { return track(eventName, properties, traits); });
                    return [2 /*return*/, null];
                }
                traits = removeEmptyStrings(traits);
                return [2 /*return*/, sdk.track(eventName, properties, traits)];
            }
            catch (error) {
                sentryWrapper.captureException(error);
                console.error(error);
            }
            return [2 /*return*/];
        });
    });
}
function page(param1, param2, param3) {
    return __awaiter(this, void 0, void 0, function () {
        var pageName, properties, traits;
        return __generator(this, function (_a) {
            try {
                if (!sdk) {
                    recordCallBeforeLoad(function () { return page(param1, param2, param3); });
                    return [2 /*return*/, null];
                }
                pageName = null;
                properties = null;
                traits = null;
                if (param1 && typeof param1 === "string") {
                    pageName = param1;
                    traits = param3 || {};
                }
                else if (param1 && typeof param1 === "object") {
                    properties = param1;
                    traits = param2 || {};
                }
                if (param2 && !properties && typeof param2 === "object") {
                    properties = param2;
                    traits = param3 || {};
                }
                traits = removeEmptyStrings(traits);
                return [2 /*return*/, sdk.page(pageName, properties, traits)];
            }
            catch (error) {
                sentryWrapper.captureException(error);
                console.error(error);
            }
            return [2 /*return*/];
        });
    });
}
function group(groupId, traits) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            try {
                if (!sdk) {
                    recordCallBeforeLoad(function () { return group(groupId, traits); });
                    return [2 /*return*/, null];
                }
                if (!groupId) {
                    throw new Error("the group id is required when calling group");
                }
                traits = removeEmptyStrings(traits);
                return [2 /*return*/, sdk.group(groupId, traits)];
            }
            catch (error) {
                sentryWrapper.captureException(error);
                console.error(error);
            }
            return [2 /*return*/];
        });
    });
}
function recordCallBeforeLoad(call) {
    try {
        while (recordingCallsBeforeLoad)
            ;
        recordingCallsBeforeLoad = true;
        callsBeforeLoad.push(call);
        recordingCallsBeforeLoad = false;
    }
    catch (error) {
        sentryWrapper.captureException(error);
        console.error(error);
    }
}
export { load, identify, track, page, group };
//# sourceMappingURL=index.js.map