var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var supportedCookies = ["_ga"];
var HttpCookieServiceImpl = /** @class */ (function () {
    function HttpCookieServiceImpl(options, browser, sentry, cookiesStore) {
        var _a, _b, _c, _d;
        this.initialCookies = {};
        if (!options.renewUrl) {
            throw new Error("Missing required renewUrl option for HttpCookieService");
        }
        this.cookiesStore = cookiesStore;
        this.sentry = sentry;
        var origin = browser.location().origin;
        this.renewUrl = new URL(options.renewUrl, origin).href;
        this.backoff = (_a = options.backoff) !== null && _a !== void 0 ? _a : 300;
        this.retries = (_b = options.retries) !== null && _b !== void 0 ? _b : 2;
        this.timeout = (_c = options.timeout) !== null && _c !== void 0 ? _c : 3000;
        this.pollingInterval = (_d = options.pollingInterval) !== null && _d !== void 0 ? _d : 300;
        if (options.enablePolling) {
            // Gather initial cookies
            this.setInitialCookies();
            // Start polling for cookies changes (when GA4 is loaded and _ga cookie is set)
            this.pollingCookieKeeper(this.pollingInterval);
        }
    }
    HttpCookieServiceImpl.prototype.pollingCookieKeeper = function (timeout) {
        var _this = this;
        setTimeout(function () { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.pollingCookieKeeper(timeout * 2); // Exponential backoff
                        // If cookies have not changed, we don't need to do anything.
                        if (!this.hasCookiesChanged()) {
                            return [2 /*return*/];
                        }
                        // When cookies have changed, and we have initial cookies, we need to revert to initial cookies.
                        if (!this.isInitialCookiesEmpty()) {
                            this.revertInitialCookies();
                            return [2 /*return*/];
                        }
                        // When cookies have changed, and we have no initial cookies, we need to persist the new cookies to the server.
                        return [4 /*yield*/, this.dispatchRenew()];
                    case 1:
                        // When cookies have changed, and we have no initial cookies, we need to persist the new cookies to the server.
                        _a.sent();
                        this.setInitialCookies();
                        return [2 /*return*/];
                }
            });
        }); }, timeout);
    };
    HttpCookieServiceImpl.prototype.revertInitialCookies = function () {
        var _this = this;
        supportedCookies.forEach(function (cookie) {
            _this.cookiesStore.set(cookie, _this.initialCookies[cookie]);
        });
    };
    HttpCookieServiceImpl.prototype.isInitialCookiesEmpty = function () {
        var _this = this;
        return supportedCookies.every(function (cookie) {
            return _this.initialCookies[cookie] === null ||
                _this.initialCookies[cookie] === undefined;
        });
    };
    HttpCookieServiceImpl.prototype.hasCookiesChanged = function () {
        var _this = this;
        return supportedCookies.some(function (cookie) {
            return _this.initialCookies[cookie] !== _this.cookiesStore.get(cookie);
        });
    };
    HttpCookieServiceImpl.prototype.setInitialCookies = function () {
        var _this = this;
        supportedCookies.forEach(function (cookie) {
            _this.initialCookies[cookie] = _this.cookiesStore.get(cookie);
        });
    };
    HttpCookieServiceImpl.prototype.sendHTTPCookies = function (serviceUrl) {
        var _this = this;
        return function () { return __awaiter(_this, void 0, void 0, function () {
            var controller, response, err, _a, _b, data, httpCookie;
            var _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        controller = new AbortController();
                        setTimeout(function () { return controller.abort(); }, this.timeout);
                        return [4 /*yield*/, fetch(serviceUrl, {
                                signal: controller.signal,
                                credentials: "include",
                                headers: {
                                    Accept: "application/json",
                                    "Content-Type": "application/json",
                                },
                                method: "POST",
                            })];
                    case 1:
                        response = _d.sent();
                        if (!!response.ok) return [3 /*break*/, 4];
                        err = new Error("Failed to request HTTP Cookies, reason: ".concat(response.statusText));
                        _b = (_a = this.sentry).setResponse;
                        _c = {
                            url: serviceUrl,
                            headers: response.headers,
                            status: response.status
                        };
                        return [4 /*yield*/, response.text()];
                    case 2: return [4 /*yield*/, _b.apply(_a, [(_c.body = _d.sent(),
                                _c)])];
                    case 3:
                        _d.sent();
                        throw err;
                    case 4: return [4 /*yield*/, response.json()];
                    case 5:
                        data = _d.sent();
                        httpCookie = {
                            anonymousId: data === null || data === void 0 ? void 0 : data.journifyio_anonymous_id,
                            userId: data === null || data === void 0 ? void 0 : data.journifyio_user_id,
                        };
                        return [2 /*return*/, httpCookie];
                }
            });
        }); };
    };
    HttpCookieServiceImpl.prototype.dispatchRenew = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, retry(this.sendHTTPCookies(this.renewUrl), this.retries, this.backoff)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return HttpCookieServiceImpl;
}());
export { HttpCookieServiceImpl };
function sleep(delayMS) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/, new Promise(function (resolve) { return setTimeout(resolve, delayMS); })];
        });
    });
}
function retry(req, retries, backoff) {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(retries >= 0)) return [3 /*break*/, 6];
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 5]);
                    return [4 /*yield*/, req()];
                case 2: return [2 /*return*/, _a.sent()];
                case 3:
                    error_1 = _a.sent();
                    if (retries <= 0)
                        throw error_1;
                    retries -= 1;
                    return [4 /*yield*/, sleep(backoff)];
                case 4:
                    _a.sent();
                    return [3 /*break*/, 5];
                case 5: return [3 /*break*/, 0];
                case 6: return [2 /*return*/];
            }
        });
    });
}
//# sourceMappingURL=httpCookieService.js.map