import { Emitter, EmitterImpl } from "../transport/emitter";
export interface WithId {
    getId(): string;
}
export interface OperationsPriorityQueue<T extends WithId> extends Emitter {
    push(...operations: T[]): boolean[];
    pushWithBackoff(operation: T): boolean;
    isEmpty(): boolean;
    pop(): T | undefined;
}
export declare class OperationsPriorityQueueImpl<T extends WithId> extends EmitterImpl implements OperationsPriorityQueue<T> {
    private delayedOperations;
    private nowOperations;
    private readonly attempts;
    private readonly maxAttempts;
    constructor(maxAttempts: number);
    push(...operations: T[]): boolean[];
    pushWithBackoff(operation: T): boolean;
    isEmpty(): boolean;
    pop(): T | undefined;
    private backoffDelayInMs;
    private newAttempt;
    private getAttempts;
    private alreadyInQueue;
}
export declare const ON_OPERATION_DELAY_FINISH = "onOperationDelayFinish";
