var StoresGroup = /** @class */ (function () {
    function StoresGroup(localStore, cookiesStore, memoryStore) {
        this.localStore = localStore;
        this.cookiesStore = cookiesStore;
        this.memoryStore = memoryStore;
    }
    StoresGroup.prototype.get = function (key) {
        var _a, _b, _c;
        return ((_c = (_b = (_a = this.localStore.get(key)) !== null && _a !== void 0 ? _a : this.cookiesStore.get(key)) !== null && _b !== void 0 ? _b : this.memoryStore.get(key)) !== null && _c !== void 0 ? _c : null);
    };
    StoresGroup.prototype.set = function (key, value) {
        this.localStore.set(key, value);
        this.cookiesStore.set(key, value);
        this.memoryStore.set(key, value);
        return value;
    };
    StoresGroup.prototype.remove = function (key) {
        this.localStore.remove(key);
        this.cookiesStore.remove(key);
        this.memoryStore.remove(key);
    };
    return StoresGroup;
}());
export { StoresGroup };
export var SESSION_ID_PERSISTENCE_KEY = "journifyio_session_id";
//# sourceMappingURL=store.js.map