var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import * as uuid from "uuid";
import { JournifyEventType } from "../domain/event";
import { LIB_VERSION } from "../generated/libVersion";
import { SESSION_ID_PERSISTENCE_KEY } from "../store/store";
import { SessionStore } from "../store/sessionStore";
var EventFactoryImpl = /** @class */ (function () {
    function EventFactoryImpl(stores, cookiesStore, browser, externalIdsSessionCache) {
        this.stores = stores;
        this.cookiesStore = cookiesStore;
        this.browser = browser;
        this.externalIdsSessionCache = externalIdsSessionCache;
    }
    EventFactoryImpl.prototype.setGroup = function (group) {
        this.group = group;
    };
    EventFactoryImpl.prototype.setUser = function (user) {
        this.user = user;
    };
    EventFactoryImpl.prototype.newIdentifyEvent = function () {
        var _a, _b, _c;
        var baseEvent = {
            type: JournifyEventType.IDENTIFY,
            userId: ((_a = this.user) === null || _a === void 0 ? void 0 : _a.getUserId()) || null,
            anonymousId: (_b = this.user) === null || _b === void 0 ? void 0 : _b.getAnonymousId(),
            traits: (_c = this.user) === null || _c === void 0 ? void 0 : _c.getTraits(),
        };
        return this.normalizeEvent(baseEvent);
    };
    EventFactoryImpl.prototype.newTrackEvent = function (eventName, properties, traits) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var mergedTraits, baseEvent;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, this.appendTraitsFromProperties(traits, properties)];
                    case 1:
                        _d.sent();
                        mergedTraits = __assign(__assign({}, (((_a = this.user) === null || _a === void 0 ? void 0 : _a.getTraits()) || {})), traits);
                        baseEvent = {
                            type: JournifyEventType.TRACK,
                            event: eventName,
                            properties: properties,
                            userId: ((_b = this.user) === null || _b === void 0 ? void 0 : _b.getUserId()) || mergedTraits.userId || null,
                            anonymousId: (_c = this.user) === null || _c === void 0 ? void 0 : _c.getAnonymousId(),
                            traits: mergedTraits,
                        };
                        return [2 /*return*/, this.normalizeEvent(baseEvent)];
                }
            });
        });
    };
    EventFactoryImpl.prototype.newPageEvent = function (pageName, properties, traits) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var mergedTraits, baseEvent;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0: return [4 /*yield*/, this.appendTraitsFromProperties(traits, properties)];
                    case 1:
                        _d.sent();
                        mergedTraits = __assign(__assign({}, (((_a = this.user) === null || _a === void 0 ? void 0 : _a.getTraits()) || {})), traits);
                        baseEvent = {
                            type: JournifyEventType.PAGE,
                            name: pageName,
                            properties: properties,
                            userId: ((_b = this.user) === null || _b === void 0 ? void 0 : _b.getUserId()) || mergedTraits.userId || null,
                            anonymousId: (_c = this.user) === null || _c === void 0 ? void 0 : _c.getAnonymousId(),
                            traits: mergedTraits,
                        };
                        return [2 /*return*/, this.normalizeEvent(baseEvent)];
                }
            });
        });
    };
    EventFactoryImpl.prototype.newGroupEvent = function () {
        var _a, _b, _c;
        var baseEvent = {
            type: JournifyEventType.GROUP,
            userId: ((_a = this.user) === null || _a === void 0 ? void 0 : _a.getUserId()) || null,
            anonymousId: (_b = this.user) === null || _b === void 0 ? void 0 : _b.getAnonymousId(),
            traits: (_c = this.group) === null || _c === void 0 ? void 0 : _c.getTraits(),
        };
        return this.normalizeEvent(baseEvent);
    };
    EventFactoryImpl.prototype.normalizeEvent = function (baseEvent) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var ctx, campaign, navigator_1, sessionId, normalizedEvent;
            return __generator(this, function (_b) {
                ctx = (baseEvent === null || baseEvent === void 0 ? void 0 : baseEvent.context) || {};
                ctx.userAgent = this.browser.navigator().userAgent;
                ctx.groupId = ((_a = this.group) === null || _a === void 0 ? void 0 : _a.getGroupId()) || null;
                ctx.page = {
                    referrer: this.browser.document().referrer,
                    search: this.browser.location().search,
                    title: this.browser.document().title,
                    path: this.browser.canonicalPath(),
                    url: this.browser.canonicalUrl(),
                };
                campaign = this.browser.utmCampaign(this.browser.location().search, new SessionStore(this.browser));
                if (campaign) {
                    ctx.campaign = campaign;
                }
                if (!ctx.locale) {
                    navigator_1 = this.browser.navigator();
                    ctx.locale = navigator_1
                        ? navigator_1.language || navigator_1["userLanguage"]
                        : undefined;
                }
                if (!ctx.library) {
                    ctx.library = {
                        name: "@journifyio/js-sdk",
                        version: LIB_VERSION,
                    };
                }
                sessionId = this.stores.get(SESSION_ID_PERSISTENCE_KEY);
                if (sessionId) {
                    ctx.session = {
                        id: sessionId,
                    };
                }
                normalizedEvent = __assign(__assign({}, baseEvent), { messageId: uuid.v4(), timestamp: new Date(), externalIds: this.getExternalIDs(), context: ctx });
                return [2 /*return*/, normalizedEvent];
            });
        });
    };
    EventFactoryImpl.prototype.appendTraitsFromProperties = function (traits, properties) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                if (properties === null || properties === void 0 ? void 0 : properties.hashed_email) {
                    traits.hashed_email = properties.hashed_email;
                }
                if (properties === null || properties === void 0 ? void 0 : properties.email) {
                    traits.email = properties.email;
                }
                if (properties === null || properties === void 0 ? void 0 : properties.hashed_phone) {
                    traits.hashed_phone = properties.hashed_phone;
                }
                if (properties === null || properties === void 0 ? void 0 : properties.phone) {
                    traits.phone = properties.phone;
                }
                return [2 /*return*/];
            });
        });
    };
    EventFactoryImpl.prototype.getExternalIDs = function () {
        var _a, _b;
        var potentialExternalIds = __assign({ facebook_click_id: this.cookiesStore.get("_fbc"), pinterest_click_id: this.cookiesStore.get("_epik"), tiktok_click_id: this.cookiesStore.get("ttclid"), snapchat_click_id: this.cookiesStore.get("_scclid"), facebook_browser_id: this.cookiesStore.get("_fbp"), snapchat_scid: this.cookiesStore.get("_scid"), tiktok_ttp: this.cookiesStore.get("_ttp"), microsoft_click_id: this.cookiesStore.get("_uetmsclkid"), linkedin_click_id: this.cookiesStore.get("li_fat_id"), google_click_id: this.getGoogleClickId(), twitter_click_id: this.getTwitterClickId(), snapchat_advertiser_cookie_1: this.cookiesStore.get("snapchat_advertiser_cookie_1") ||
                ((_a = this.user) === null || _a === void 0 ? void 0 : _a.getAnonymousId()) }, this.externalIdsSessionCache.getExternalIds());
        var userExternalIds = (_b = this.user) === null || _b === void 0 ? void 0 : _b.getExternalIds();
        if (userExternalIds) {
            for (var key in userExternalIds) {
                potentialExternalIds[key] = userExternalIds[key];
            }
        }
        return Object.entries(potentialExternalIds).reduce(function (accumulator, _a) {
            var key = _a[0], value = _a[1];
            if (value) {
                accumulator[key] = "" + value;
            }
            return accumulator;
        }, {});
    };
    EventFactoryImpl.prototype.getGoogleClickId = function () {
        var gclAwID = this.getGoogleClickIdFromGclCookie("_gcl_aw");
        if ((gclAwID === null || gclAwID === void 0 ? void 0 : gclAwID.length) > 0) {
            return gclAwID;
        }
        var gclDcId = this.getGoogleClickIdFromGclCookie("_gcl_dc");
        if ((gclDcId === null || gclDcId === void 0 ? void 0 : gclDcId.length) > 0) {
            return gclDcId;
        }
        var fpgClaw = this.getGoogleClickIdFromFPGCookie("FPGCLAW");
        if ((fpgClaw === null || fpgClaw === void 0 ? void 0 : fpgClaw.length) > 0) {
            return fpgClaw;
        }
        return this.getGoogleClickIdFromFPGCookie("FPGCLDC");
    };
    EventFactoryImpl.prototype.getGoogleClickIdFromGclCookie = function (cookieName) {
        var cookieValue = this.cookiesStore.get(cookieName);
        if (!cookieValue) {
            return null;
        }
        var split = cookieValue.split(".");
        if (split.length < 3) {
            return null;
        }
        return split.slice(2).join("");
    };
    EventFactoryImpl.prototype.getGoogleClickIdFromFPGCookie = function (cookieName) {
        var cookieValue = this.cookiesStore.get(cookieName);
        if (!cookieValue) {
            return null;
        }
        var startIndex = cookieValue.indexOf(".k");
        if (startIndex === -1) {
            return null;
        }
        var endIndex = cookieValue.indexOf("$", startIndex);
        if (endIndex === -1) {
            return null;
        }
        return cookieValue.substring(startIndex + 2, endIndex);
    };
    EventFactoryImpl.prototype.getTwitterClickId = function () {
        var cookie = this.cookiesStore.get("_twclid");
        if (!cookie) {
            return cookie;
        }
        try {
            cookie = decodeURI(cookie);
            var obj = JSON.parse(cookie);
            if (obj === null || obj === void 0 ? void 0 : obj.twclid) {
                return obj.twclid;
            }
            return cookie;
        }
        catch (e) {
            return cookie;
        }
    };
    return EventFactoryImpl;
}());
export { EventFactoryImpl };
//# sourceMappingURL=eventFactory.js.map