var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { toSettingsObject } from "../lib/settings";
import { getStoredIdentify } from "../lib/identify";
import { hashPII } from "../lib/hashPII";
import { matchFilters } from "../lib/filters";
// Event Paramaters https://help.ads.microsoft.com/apex/index/3/en/60123
var BingAdsTag = /** @class */ (function () {
    function BingAdsTag(deps) {
        this.name = "bing_ads_tag";
        this.browser = deps.browser;
        this.user = deps.user;
        this.testingMode = deps.testingWriteKey;
        this.enableHashing = deps.enableHashing;
        this.fieldsMapper = deps.fieldMapperFactory.newFieldMapper(deps.sync.field_mappings);
        this.eventMapper = deps.eventMapperFactory.newEventMapper(deps.sync.event_mappings);
        this.settings = {};
        this.logger = deps.logger;
        this.init(deps.sync);
    }
    BingAdsTag.prototype.updateSettings = function (sync) {
        this.init(sync);
    };
    BingAdsTag.prototype.identify = function (ctx) {
        return __awaiter(this, void 0, void 0, function () {
            var newEvent, storedEvent, traits, pid;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        newEvent = ctx.getEvent();
                        storedEvent = getStoredIdentify(this.user);
                        traits = __assign(__assign({}, (storedEvent.traits || {})), (newEvent.traits || {}));
                        if (!this.enableHashing) return [3 /*break*/, 2];
                        return [4 /*yield*/, hashPII(traits)];
                    case 1:
                        traits = _a.sent();
                        _a.label = 2;
                    case 2:
                        pid = {};
                        if (traits.email) {
                            pid["em"] = traits.email;
                        }
                        if (traits.phone) {
                            pid["ph"] = traits.phone;
                        }
                        this.browser.window().uetq.push("set", { pid: pid });
                        return [2 /*return*/, ctx];
                }
            });
        });
    };
    BingAdsTag.prototype.track = function (ctx) {
        var _a;
        var event = ctx.getEvent();
        var eventMapping = this.eventMapper.getEventMapping(event);
        if (!eventMapping || !matchFilters(event, eventMapping === null || eventMapping === void 0 ? void 0 : eventMapping.filters)) {
            return ctx;
        }
        var mappedProperties = this.fieldsMapper.mapEvent(event);
        (_a = this.browser
            .window()) === null || _a === void 0 ? void 0 : _a.uetq.push("event", eventMapping.pixelEventName, mappedProperties);
        return ctx;
    };
    BingAdsTag.prototype.page = function (ctx) {
        var _a;
        (_a = this.browser.window().uetq) === null || _a === void 0 ? void 0 : _a.push("pageLoad");
        return ctx;
    };
    BingAdsTag.prototype.group = function (ctx) {
        return ctx;
    };
    BingAdsTag.prototype.init = function (sync) {
        this.settings = toSettingsObject(sync.settings);
        if (!this.settings.bing_ads_tag_id) {
            this.logger.log("Bing Ads Tag is not injected because the pixel id is not set.");
            return;
        }
        this.loadScript(this.settings.bing_ads_tag_id);
    };
    BingAdsTag.prototype.loadScript = function (bingAdsTagId) {
        var localWindow = this.browser.window();
        if (localWindow.uetq) {
            return;
        }
        var scriptUrl = "https://bat.bing.com/bat.js";
        var async = true;
        var onload = function () {
            localWindow.uetq = localWindow.uetq || [];
            var setup = {
                ti: bingAdsTagId,
                q: localWindow.uetq,
            };
            localWindow.uetq = new localWindow.UET(setup);
        };
        var opts = {
            async: async,
            onload: onload,
        };
        this.browser.injectScript(scriptUrl, opts);
    };
    return BingAdsTag;
}());
export { BingAdsTag };
//# sourceMappingURL=bing_ads_tag.js.map