var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { toSettingsObject } from "../lib/settings";
import _ from "lodash";
import { hashPII } from "../lib/hashPII";
var CleverTapPlugin = /** @class */ (function () {
    function CleverTapPlugin(deps) {
        this.name = "celvertap";
        this.user = deps.user;
        this.sdk = deps.externalSDK;
        this.enableHashing = deps.enableHashing;
        this.init(deps.sync);
    }
    CleverTapPlugin.prototype.identify = function (ctx) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var traits, siteData, _i, _c, _d, key, value;
            return __generator(this, function (_e) {
                switch (_e.label) {
                    case 0:
                        traits = ((_a = ctx.getEvent()) === null || _a === void 0 ? void 0 : _a.traits) || {};
                        if (this.user) {
                            traits = __assign(__assign({}, this.user.getTraits()), traits);
                        }
                        if (!this.enableHashing) return [3 /*break*/, 2];
                        return [4 /*yield*/, hashPII(traits)];
                    case 1:
                        traits = _e.sent();
                        _e.label = 2;
                    case 2:
                        siteData = {
                            Identity: (_b = this.user) === null || _b === void 0 ? void 0 : _b.getUserId(),
                        };
                        for (_i = 0, _c = Object.entries(traits); _i < _c.length; _i++) {
                            _d = _c[_i], key = _d[0], value = _d[1];
                            switch (key) {
                                case "birthday":
                                    siteData.DOB = value;
                                    break;
                                case "avatar":
                                    siteData.Photo = value;
                                    break;
                                case "gender":
                                    siteData.Gender = value.charAt(0).toUpperCase();
                                    break;
                                case "email":
                                    siteData.Email = value;
                                    break;
                                case "phone":
                                    siteData.Phone = value;
                                    break;
                                case "name":
                                    siteData.Name = value;
                                    break;
                                default:
                                    siteData[key] = value;
                            }
                        }
                        this.sdk.pushProfileData({ Site: siteData });
                        return [2 /*return*/, ctx];
                }
            });
        });
    };
    CleverTapPlugin.prototype.page = function (ctx) {
        var event = ctx.getEvent();
        var eventPage = event.context.page;
        var cleverTapEventProps = __assign({ Referrer: eventPage.referrer, Search: eventPage.search, Title: eventPage.title, Path: eventPage.path, URL: eventPage.url, UserAgent: event.context.userAgent }, event.properties);
        this.sdk.pushEvent("Web Page Viewed", cleverTapEventProps);
        return ctx;
    };
    CleverTapPlugin.prototype.track = function (ctx) {
        var event = ctx.getEvent();
        var eventName = event.event;
        if (eventName === "Order Completed") {
            eventName = "Charged";
        }
        var eventProps = event.properties;
        for (var _i = 0, _a = Object.entries(eventProps); _i < _a.length; _i++) {
            var _b = _a[_i], key = _b[0], value = _b[1];
            if (_.isObject(value) || _.isArray(value)) {
                eventProps[key] = JSON.stringify(value);
            }
        }
        this.sdk.pushEvent(eventName, event.properties);
        return ctx;
    };
    CleverTapPlugin.prototype.updateSettings = function (sync) {
        this.init(sync);
    };
    CleverTapPlugin.prototype.group = function (ctx) {
        return ctx;
    };
    CleverTapPlugin.prototype.init = function (sync) {
        var _a;
        var settings = toSettingsObject(sync.settings);
        this.sdk.init(settings.account_id, (_a = settings.region) === null || _a === void 0 ? void 0 : _a.trim());
    };
    return CleverTapPlugin;
}());
export { CleverTapPlugin };
//# sourceMappingURL=cleverTapPlugin.js.map