import { Sync, Plugin, PluginDependencies } from "../plugin";
import { Context } from "../../context";
declare global {
    interface Window {
        fbq?: (...args: any[]) => void;
        _fbq?: (...args: any[]) => void;
    }
}
export declare class FacebookPixel implements Plugin {
    readonly name = "facebook";
    private settings;
    private readonly user;
    private readonly browser;
    private readonly fieldsMapper;
    private readonly eventMapper;
    private readonly testingMode;
    private readonly logger;
    constructor(deps: PluginDependencies);
    track(ctx: Context): Context;
    page(ctx: Context): Context;
    group(ctx: Context): Context;
    identify(ctx: Context): Context;
    updateSettings(sync: Sync): void;
    private trackPixelEvent;
    private removeUserData;
    private init;
    private loadFbScript;
    private initPixel;
    private callPixelHelper;
    private mapUserData;
}
