var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
/* eslint-disable  @typescript-eslint/no-explicit-any */
import { JournifyEventType } from "../../../domain/event";
import { getStoredIdentify } from "../lib/identify";
import { toSettingsObject } from "../lib/settings";
import { hashPII } from "../lib/hashPII";
var GA4Pixel = /** @class */ (function () {
    function GA4Pixel(deps) {
        this.name = "ga4_pixel";
        this.user = deps.user;
        this.browser = deps.browser;
        this.testingMode = deps.testingWriteKey;
        this.logger = deps.logger;
        this.enableHashing = deps.enableHashing;
        this.init(deps.sync);
    }
    // implement the interface
    GA4Pixel.prototype.identify = function (ctx) {
        return __awaiter(this, void 0, void 0, function () {
            var newEvent, storedEvent, event, _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        newEvent = ctx.getEvent();
                        storedEvent = getStoredIdentify(this.user);
                        event = {
                            type: JournifyEventType.IDENTIFY,
                            userId: newEvent.userId || storedEvent.userId,
                            anonymousId: newEvent.anonymousId || storedEvent.anonymousId,
                            traits: __assign(__assign({}, (storedEvent.traits || {})), (newEvent.traits || {})),
                        };
                        if (!this.enableHashing) return [3 /*break*/, 2];
                        _a = event;
                        return [4 /*yield*/, hashPII(event.traits)];
                    case 1:
                        _a.traits = _b.sent();
                        _b.label = 2;
                    case 2:
                        if (Object.keys(event.traits).length > 0) {
                            window.gtag("set", "user_properties", event.traits);
                        }
                        this.browser.window().gtag("config", this.settings.mesurement_id, {
                            user_id: event.userId,
                        });
                        return [2 /*return*/, ctx];
                }
            });
        });
    };
    GA4Pixel.prototype.track = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    GA4Pixel.prototype.page = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    GA4Pixel.prototype.group = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    GA4Pixel.prototype.updateSettings = function (sync) {
        this.init(sync);
    };
    GA4Pixel.prototype.trackPixelEvent = function (ctx) {
        var event = ctx.getEvent();
        this.callPixelHelper(event.type, event.event, event.properties);
        return ctx;
    };
    GA4Pixel.prototype.callPixelHelper = function (type, event, args) {
        switch (type) {
            case JournifyEventType.PAGE:
                if (this.testingMode) {
                    return this.logger.log("Will call window.gtag with the following params in order:", ["event", "page_view", args]);
                }
                this.browser.window().gtag("event", "page_view", args);
                break;
            case JournifyEventType.GROUP:
                if (this.testingMode) {
                    return this.logger.log("Will call window.gtag with the following params in order:", ["event", "join_group", args]);
                }
                this.browser.window().gtag("event", "join_group", args);
                break;
            default:
                if (this.testingMode) {
                    return this.logger.log("Will call window.gtag with the following params in order:", ["event", event, args]);
                }
                this.browser.window().gtag("event", event, args);
        }
    };
    GA4Pixel.prototype.init = function (sync) {
        this.settings = toSettingsObject(sync.settings);
        this.loadScript(this.settings.mesurement_id);
    };
    GA4Pixel.prototype.loadScript = function (measurementID) {
        var localWindow = this.browser.window();
        localWindow.JDataLayer = localWindow.JDataLayer || [];
        // Using a custom data layer to avoid conflicts with gtags
        // Docs: https://developers.google.com/tag-platform/tag-manager/datalayer?hl=en#rename_the_data_layer
        localWindow.gtag = function gtag() {
            // This is very important to use the arguments object here, and it's not possible to use rest parameters
            // Pushing to our custom data layer
            // eslint-disable-next-line prefer-rest-params
            localWindow.JDataLayer.push(arguments);
        };
        localWindow.gtag("js", new Date());
        localWindow.gtag("config", measurementID);
        // Load the gtag script with l paramater to set the new data layer name
        this.browser.injectScript("https://www.googletagmanager.com/gtag/js?id=".concat(measurementID, "&l=JDataLayer"), { async: true });
    };
    return GA4Pixel;
}());
export { GA4Pixel };
//# sourceMappingURL=ga4PPixel.js.map