import { Plugin, PluginDependencies, Sync } from "../plugin";
import { Context } from "../../context";
declare global {
    interface Window {
        gtag?: (...args: any[]) => void;
        dataLayer?: any[];
    }
}
export declare class GoogleAdsGtag implements Plugin {
    readonly name: string;
    private settings;
    private readonly user;
    private readonly browser;
    private readonly fieldsMapper;
    private readonly eventMapper;
    private readonly testingMode;
    private readonly logger;
    constructor(deps: PluginDependencies);
    track(ctx: Context): Promise<Context> | Context;
    page(ctx: Context): Promise<Context> | Context;
    group(ctx: Context): Promise<Context> | Context;
    identify(ctx: Context): Promise<Context> | Context;
    updateSettings(sync: Sync): void;
    private trackGtagEvent;
    private parseMappedEventName;
    private init;
    private loadGtagScript;
    private initTag;
    private setUserData;
    private mapUserData;
    private gtag;
    private removeUserInitData;
}
