var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { hashPII } from "../lib/hashPII";
var DEFAULT_API_HOST = "https://t.journify.io";
// this is used to limit the size of the request body to prevent issues with large payloads
var MAX_REQUEST_BODY_SIZE_KB = 16; // 16KB
var JournifyioPlugin = /** @class */ (function () {
    function JournifyioPlugin(sdkConfig, sentry) {
        this.name = "journifyio";
        this.identify = this.post;
        this.track = this.post;
        this.page = this.post;
        this.group = this.post;
        this.sdkSettings = sdkConfig;
        this.sentry = sentry;
    }
    JournifyioPlugin.prototype.updateSettings = function (settings) {
        this.sdkSettings = settings;
    };
    JournifyioPlugin.prototype.post = function (ctx) {
        var _a, _b, _c, _d, _e, _f;
        return __awaiter(this, void 0, void 0, function () {
            var apiHost, event, _g, _h, eventUrl, requestBody, requestBodyStr, requestBodyBytes, response, _j, _k;
            var _l;
            return __generator(this, function (_m) {
                switch (_m.label) {
                    case 0:
                        apiHost = (_a = this.sdkSettings.apiHost) !== null && _a !== void 0 ? _a : DEFAULT_API_HOST;
                        event = ctx.getEvent();
                        if (!(((_c = (_b = this.sdkSettings) === null || _b === void 0 ? void 0 : _b.options) === null || _c === void 0 ? void 0 : _c.enableHashing) === true)) return [3 /*break*/, 3];
                        _g = event;
                        return [4 /*yield*/, hashPII(event.traits)];
                    case 1:
                        _g.traits = _m.sent();
                        _h = event;
                        return [4 /*yield*/, hashPII(event.externalIds)];
                    case 2:
                        _h.externalIds = _m.sent();
                        _m.label = 3;
                    case 3:
                        if (((_d = event.traits) === null || _d === void 0 ? void 0 : _d.hashed_email) && !event.traits.email) {
                            event.traits.email = event.traits.hashed_email;
                            delete event.traits.hashed_email;
                        }
                        if (((_e = event.traits) === null || _e === void 0 ? void 0 : _e.hashed_phone) && !event.traits.phone) {
                            event.traits.phone = event.traits.hashed_phone;
                            delete event.traits.hashed_phone;
                        }
                        eventUrl = "".concat(apiHost, "/v1/").concat((_f = event.type) === null || _f === void 0 ? void 0 : _f.charAt(0));
                        requestBody = __assign(__assign({}, event), { writeKey: this.sdkSettings.writeKey });
                        requestBodyStr = JSON.stringify(requestBody);
                        requestBodyBytes = new TextEncoder().encode(requestBodyStr).length;
                        if (requestBodyBytes > MAX_REQUEST_BODY_SIZE_KB * 1024) {
                            throw new Error("Your event is ignored because the request body exceeds ".concat(MAX_REQUEST_BODY_SIZE_KB, "Kb limit."));
                        }
                        this.sentry.setTag("eventUrl", eventUrl);
                        this.sentry.setTag("writeKey", requestBody.writeKey);
                        return [4 /*yield*/, fetch(eventUrl, {
                                method: "POST",
                                headers: {
                                    "Content-Type": "application/json",
                                },
                                body: requestBodyStr,
                                keepalive: true,
                            })];
                    case 4:
                        response = _m.sent();
                        if (!!response.ok) return [3 /*break*/, 6];
                        _k = (_j = this.sentry).setResponse;
                        _l = {
                            url: eventUrl,
                            headers: response.headers,
                            status: response.status
                        };
                        return [4 /*yield*/, response.text()];
                    case 5:
                        _k.apply(_j, [(_l.body = _m.sent(),
                                _l)]);
                        // Only throw error if it's 5xx (server errors) error to retry
                        if (response.status >= 500) {
                            throw new Error("POST request to ".concat(eventUrl, " returned ").concat(response.status, " HTTP status"));
                        }
                        _m.label = 6;
                    case 6: return [2 /*return*/, ctx];
                }
            });
        });
    };
    return JournifyioPlugin;
}());
export { JournifyioPlugin };
//# sourceMappingURL=journifyio.js.map