import { FilterOperator } from "../plugin";
import _ from "lodash";
export function matchFilters(event, filters) {
    if (filters) {
        for (var _i = 0, filters_1 = filters; _i < filters_1.length; _i++) {
            var filter = filters_1[_i];
            if (!matchFilter(event, filter)) {
                return false;
            }
        }
    }
    return true;
}
function matchFilter(event, filter) {
    var _a;
    var eventValue = _.get(event, filter.field);
    switch (filter.operator) {
        case FilterOperator.EQUALS:
            if (filter.value === eventValue) {
                return true;
            }
            return (_a = filter.value) === null || _a === void 0 ? void 0 : _a.includes(eventValue);
        case FilterOperator.NOT_EQUALS:
            return filter.value !== eventValue;
        case FilterOperator.CONTAINS:
            return eventValue === null || eventValue === void 0 ? void 0 : eventValue.includes(filter.value);
        case FilterOperator.NOT_CONTAINS:
            return !(eventValue === null || eventValue === void 0 ? void 0 : eventValue.includes(filter.value));
        case FilterOperator.STARTS_WITH:
            return eventValue === null || eventValue === void 0 ? void 0 : eventValue.startsWith(filter.value);
        case FilterOperator.ENDS_WITH:
            return eventValue === null || eventValue === void 0 ? void 0 : eventValue.endsWith(filter.value);
        case FilterOperator.GREATER_THAN:
            return eventValue > filter.value;
        case FilterOperator.GREATER_THAN_OR_EQ:
            return eventValue >= filter.value;
        case FilterOperator.LESS_THAN:
            return eventValue < filter.value;
        case FilterOperator.LESS_THAN_OR_EQ:
            return eventValue <= filter.value;
    }
    return false;
}
//# sourceMappingURL=filters.js.map