import { EventMapping, FieldMapping, PixelEventMapping } from "../plugin";
import { Transformation } from "./tranformations";
import { JournifyEvent } from "../../../domain/event";
export interface FieldsMapperFactory {
    newFieldMapper(fieldMappings: FieldMapping[], now?: () => Date): FieldsMapper;
}
export interface FieldsMapper {
    mapEvent(event: object, transformationsMap?: Record<string, Transformation[]>, options?: {
        ignoreUnmappedProperties: boolean;
    }): Record<string, any>;
}
export declare class FieldsMapperFactoryImpl implements FieldsMapperFactory {
    newFieldMapper(fieldMappings: FieldMapping[], now?: () => Date): FieldsMapper;
}
export interface EventMapperFactory {
    newEventMapper(eventMappings: EventMapping[]): EventMapper;
}
export interface EventMapper {
    getEventMapping(event: JournifyEvent): PixelEventMapping | null;
}
export declare class EventMapperFactoryImpl implements EventMapperFactory {
    newEventMapper(eventMappings: EventMapping[]): EventMapper;
}
export declare class EventMapperImpl implements EventMapper {
    private readonly eventMappings;
    private readonly pageEventsMapping;
    private readonly trackEventsMapping;
    private readonly groupEventsMapping;
    private readonly identifyEventsMapping;
    constructor(eventMappings: EventMapping[]);
    getEventMapping(event: JournifyEvent): PixelEventMapping | null;
    private init;
}
