import { Sync, Plugin, PluginDependencies } from "../plugin";
import { Context } from "../../context";
declare global {
    interface Window {
        snaptr?: (...args: any[]) => void;
    }
}
export declare class SnapchatPixel implements Plugin {
    readonly name = "snapchat_pixel";
    private readonly browser;
    private readonly user;
    private readonly fieldMapperFactory;
    private readonly eventMapperFactory;
    private readonly testingMode;
    private readonly logger;
    private settings;
    private fieldsMapper;
    private eventMapper;
    constructor(deps: PluginDependencies);
    identify(ctx: Context): Context;
    track(ctx: Context): Context;
    group(ctx: Context): Context;
    updateSettings(sync: Sync): void;
    page(ctx: Context): Context;
    private trackPixelEvent;
    private transformProperties;
    private init;
    private initPixel;
    private callPixelHelper;
    private mapUserData;
    private loadScript;
}
