var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { matchFilters } from "../lib/filters";
import { EventMapperImpl, } from "../lib/mapping";
import { toSettingsObject } from "../lib/settings";
var X_PIXEL_SCRIPT_URL = "https://static.ads-twitter.com/uwt.js";
var XPixel = /** @class */ (function () {
    function XPixel(deps) {
        this.name = "x_pixel";
        this.eventMapper = deps.eventMapperFactory.newEventMapper(deps.sync.event_mappings);
        this.browser = deps.browser;
        this.fieldMapperFactory = deps.fieldMapperFactory;
        this.testingMode = deps.testingWriteKey;
        this.logger = deps.logger;
        this.init(deps.sync);
    }
    XPixel.prototype.identify = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    XPixel.prototype.track = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    XPixel.prototype.group = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    XPixel.prototype.updateSettings = function (sync) {
        this.init(sync);
    };
    XPixel.prototype.page = function (ctx) {
        return this.trackPixelEvent(ctx);
    };
    XPixel.prototype.trackPixelEvent = function (ctx) {
        var event = ctx.getEvent();
        var eventMapping = this.eventMapper.getEventMapping(event);
        if (!eventMapping || !matchFilters(event, eventMapping === null || eventMapping === void 0 ? void 0 : eventMapping.filters)) {
            return ctx;
        }
        var mappedProperties = this.fieldsMapper.mapEvent(event, {}, { ignoreUnmappedProperties: true });
        this.callPixelHelper("event", "tw-".concat(this.settings.x_pixel_id, "-").concat(eventMapping.pixelEventName), mappedProperties);
        return ctx;
    };
    XPixel.prototype.init = function (sync) {
        this.fieldsMapper = this.fieldMapperFactory.newFieldMapper(sync.field_mappings);
        this.eventMapper = new EventMapperImpl(sync.event_mappings);
        this.settings = toSettingsObject(sync.settings);
        if (this.testingMode) {
            this.logger.log("X Pixel ".concat(this.settings.x_pixel_id, " is detected, but script is not injected because you are using a testing write key."));
        }
        else {
            this.loadScript();
        }
        this.initPixel();
    };
    XPixel.prototype.initPixel = function () {
        this.callPixelHelper("config", this.settings.x_pixel_id);
    };
    XPixel.prototype.callPixelHelper = function (trackingType) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this.testingMode) {
            this.logger.log("Will call window.twq with the following params in order:", __spreadArray([trackingType], args, true));
        }
        else {
            (_a = this.browser.window()).twq.apply(_a, __spreadArray([trackingType], args, false));
        }
    };
    /* eslint-disable */
    XPixel.prototype.loadScript = function () {
        var localWindow = this.browser.window();
        if (localWindow.twq)
            return;
        var localDocument = this.browser.document();
        var s, u, a;
        s = localWindow.twq = function () {
            s.exe ? s.exe.apply(s, arguments) : s.queue.push(arguments);
        };
        s.version = "1.1";
        s.queue = [];
        u = localDocument.createElement("script");
        u.async = !0;
        u.src = X_PIXEL_SCRIPT_URL;
        a = localDocument.getElementsByTagName("script")[0];
        a.parentNode.insertBefore(u, a);
    };
    return XPixel;
}());
export { XPixel };
//# sourceMappingURL=xPixel.js.map