var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { ContextFactoryImpl } from "./context";
import { ON_OPERATION_DELAY_FINISH, } from "../lib/priorityQueue";
import { EmitterImpl } from "./emitter";
var FLUSH_EVENT_NAME = "flush";
var EventQueueImpl = /** @class */ (function (_super) {
    __extends(EventQueueImpl, _super);
    function EventQueueImpl(plugins, pQueue, browser, sentry, contextFactory) {
        if (contextFactory === void 0) { contextFactory = new ContextFactoryImpl(); }
        var _this = _super.call(this) || this;
        _this.plugins = [];
        _this.flushing = false;
        _this.plugins = plugins;
        _this.pQueue = pQueue;
        _this.pQueue.on(ON_OPERATION_DELAY_FINISH, function () { return __awaiter(_this, void 0, void 0, function () {
            var error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.flush()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        this.sentry.captureException(error_1);
                        console.error(error_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); });
        _this.browser = browser;
        _this.sentry = sentry;
        _this.contextFactory = contextFactory;
        return _this;
    }
    EventQueueImpl.prototype.push = function (ctx) {
        var _a;
        var _this = this;
        var updatedContextEvents = this.plugins.map(function (p) {
            var newId = generateNewIDWithPlugin(ctx.getId(), p.name);
            var newCtx = _this.contextFactory.newContext(ctx.getEvent(), newId);
            return newCtx;
        });
        (_a = this.pQueue).push.apply(_a, updatedContextEvents);
        return updatedContextEvents;
    };
    EventQueueImpl.prototype.deliver = function (ctx) {
        return __awaiter(this, void 0, void 0, function () {
            var updatedContexts, _i, updatedContexts_1, c;
            return __generator(this, function (_a) {
                updatedContexts = this.push(ctx);
                for (_i = 0, updatedContexts_1 = updatedContexts; _i < updatedContexts_1.length; _i++) {
                    c = updatedContexts_1[_i];
                    this.subscribeToDelivery(c);
                    this.flush();
                }
                return [2 /*return*/, ctx];
            });
        });
    };
    EventQueueImpl.prototype.subscribeToDelivery = function (sentCtx) {
        var _this = this;
        this.on(FLUSH_EVENT_NAME, function (flushedCtx, delivered) {
            var _a;
            if (!flushedCtx.isSame(sentCtx) || delivered) {
                return;
            }
            var failureReason = (_a = flushedCtx.getFailedDelivery()) === null || _a === void 0 ? void 0 : _a.reason;
            _this.sentry.captureException(failureReason);
            console.error(failureReason);
        });
    };
    EventQueueImpl.prototype.flush = function () {
        return __awaiter(this, void 0, void 0, function () {
            var ctxToDeliver;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        while (this.flushing)
                            ;
                        this.flushing = true;
                        if (this.pQueue.isEmpty() || !this.browser.isOnline()) {
                            this.flushing = false;
                            return [2 /*return*/];
                        }
                        ctxToDeliver = this.pQueue.pop();
                        this.flushing = false;
                        if (!ctxToDeliver) {
                            return [2 /*return*/];
                        }
                        return [4 /*yield*/, new Promise(function (resolve, reject) {
                                setTimeout(function () {
                                    var plugin = _this.plugins.find(function (p) {
                                        return ctxToDeliver.getId().includes(p.name);
                                    });
                                    if (plugin) {
                                        _this.attempt(plugin, ctxToDeliver).then(resolve).catch(reject);
                                    }
                                    else {
                                        _this.sentry.captureMessage("unable to find a plugin for given event", null, {
                                            data: {
                                                event: ctxToDeliver,
                                            },
                                        });
                                    }
                                }, 0);
                            })];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    EventQueueImpl.prototype.attempt = function (plugin, ctxToDeliver) {
        return __awaiter(this, void 0, void 0, function () {
            var deliveredCtx, err_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, this.runPlugin(ctxToDeliver, plugin)];
                    case 1:
                        deliveredCtx = _a.sent();
                        this.emit(FLUSH_EVENT_NAME, deliveredCtx, true);
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        this.handleFlushError(ctxToDeliver, plugin, err_1);
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    EventQueueImpl.prototype.runPlugin = function (ctxToDeliver, plugin) {
        return __awaiter(this, void 0, void 0, function () {
            var event, hook;
            return __generator(this, function (_a) {
                event = ctxToDeliver.getEvent();
                if (!plugin || !plugin[event.type]) {
                    return [2 /*return*/, ctxToDeliver];
                }
                hook = plugin[event.type];
                return [2 /*return*/, hook.apply(plugin, [ctxToDeliver])];
            });
        });
    };
    EventQueueImpl.prototype.handleFlushError = function (ctxToDeliver, plugin, err) {
        var retryAccepted = this.pQueue.pushWithBackoff(ctxToDeliver);
        if (!retryAccepted) {
            ctxToDeliver.setFailedDelivery({ reason: err });
            this.emit(FLUSH_EVENT_NAME, ctxToDeliver, false);
        }
    };
    return EventQueueImpl;
}(EmitterImpl));
export { EventQueueImpl };
function generateNewIDWithPlugin(id, plugin) {
    return "".concat(id, "/").concat(plugin);
}
//# sourceMappingURL=queue.js.map