import { GROUP_TRAITS_PERSISTENCE_KEY } from "./traits";
const GROUP_ID_PERSISTENCE_KEY = "journifyio_group_id";
export class GroupFactoryImpl {
    constructor(stores) {
        this.stores = stores;
    }
    loadGroup() {
        return new GroupImpl(this.stores);
    }
}
class GroupImpl {
    constructor(stores) {
        this.traits = {};
        this.stores = stores;
        this.initGroupId();
        this.initTraits();
    }
    identify(groupId, traits = {}) {
        if (groupId) {
            this.setGroupId(groupId);
        }
        const newTraits = Object.assign(Object.assign({}, this.getTraits()), traits);
        this.setTraits(newTraits);
    }
    getGroupId() {
        return this.groupId;
    }
    getTraits() {
        return this.traits;
    }
    initGroupId() {
        this.groupId = this.stores.get(GROUP_ID_PERSISTENCE_KEY);
        if (this.groupId) {
            this.stores.set(GROUP_ID_PERSISTENCE_KEY, this.groupId);
        }
    }
    initTraits() {
        const traits = this.stores.get(GROUP_TRAITS_PERSISTENCE_KEY);
        this.setTraits(traits);
    }
    setTraits(newTraits) {
        const traits = Object.assign(Object.assign({}, this.traits), (newTraits !== null && newTraits !== void 0 ? newTraits : {}));
        this.stores.set(GROUP_TRAITS_PERSISTENCE_KEY, traits);
    }
    setGroupId(groupId) {
        this.groupId = groupId;
        this.stores.set(GROUP_ID_PERSISTENCE_KEY, groupId);
    }
}
//# sourceMappingURL=group.js.map