import { Browser } from "../transport/browser";
import { SentryWrapper } from "./sentry";
import { Store } from "../store/store";
export type HttpCookieOptions = {
    renewUrl: string;
    enablePolling?: boolean;
    pollingInterval?: number;
    backoff?: number;
    retries?: number;
    timeout?: number;
};
export type HttpCookieResponse = {
    anonymousId: string;
    userId?: string;
};
export interface HttpCookieService {
    dispatchRenew(): Promise<HttpCookieResponse>;
}
export declare class HttpCookieServiceImpl implements HttpCookieService {
    private renewUrl;
    private retries;
    private backoff;
    private timeout;
    private pollingInterval;
    private readonly sentry;
    private initialCookies;
    private cookiesStore;
    constructor(options: HttpCookieOptions, browser: Browser, sentry: SentryWrapper, cookiesStore: Store);
    private pollingCookieKeeper;
    private revertInitialCookies;
    private isInitialCookiesEmpty;
    private hasCookiesChanged;
    private setInitialCookies;
    private sendHTTPCookies;
    dispatchRenew(): Promise<HttpCookieResponse>;
}
