import type { Primitive } from "@sentry/types";
import type { SeverityLevel } from "@sentry/types";
import type { EventHint } from "@sentry/types";
export interface SentryWrapper {
    setTag(key: string, value: Primitive): void;
    setResponse(response: SimpleResponse): Promise<void>;
    captureMessage(message: string, level?: SeverityLevel, hint?: EventHint): string;
    captureException(error: unknown, hint?: EventHint): string;
}
export type SimpleResponse = {
    url: string;
    headers: Headers;
    status: number;
    body: string;
};
export declare class SentryWrapperImpl implements SentryWrapper {
    private readonly scope;
    constructor();
    captureMessage(message: string, level?: SeverityLevel, hint?: EventHint): string;
    captureException(error: unknown, hint?: EventHint): string;
    setResponse(response: SimpleResponse): Promise<void>;
    setTag(key: string, value: Primitive): void;
}
