import { BrowserStore } from "./browserStore";
import { CookiesStore } from "./cookiesStore";
import { MemoryStore } from "./memoryStore";
import { NullStore } from "./nullStore";
export interface Store {
    get<T>(key: string): T | null;
    set<T>(key: string, value: T | null): T | null;
    remove(key: string): void;
}
export declare class StoresGroup implements Store {
    private localStore;
    private cookiesStore;
    private memoryStore;
    constructor(localStore: BrowserStore<Storage> | MemoryStore | NullStore, cookiesStore: CookiesStore | MemoryStore | NullStore, memoryStore: MemoryStore | NullStore);
    get<T>(key: string): T | null;
    set<T>(key: string, value: T): T | null;
    remove(key: string): void;
}
export declare const SESSION_ID_PERSISTENCE_KEY = "journifyio_session_id";
