export interface Emitter {
    on(event: string, callback: Callback): Emitter;
    once(event: string, fn: Callback): Emitter;
    off(event: string, callback: Callback): Emitter;
    emit(event: string, ...args: unknown[]): Emitter;
}
type Callback = (...args: unknown[]) => void;
export declare class EmitterImpl implements Emitter {
    private callbacks;
    on(event: string, callback: Callback): this;
    once(event: string, fn: Callback): this;
    off(event: string, callback: Callback): this;
    emit(event: string, ...args: unknown[]): this;
}
export {};
