export class EmitterImpl {
    constructor() {
        this.callbacks = {};
    }
    on(event, callback) {
        var _a;
        this.callbacks[event] = [...((_a = this.callbacks[event]) !== null && _a !== void 0 ? _a : []), callback];
        return this;
    }
    once(event, fn) {
        const on = (...args) => {
            this.off(event, on);
            fn.apply(this, args);
        };
        this.on(event, on);
        return this;
    }
    off(event, callback) {
        var _a;
        const fns = (_a = this.callbacks[event]) !== null && _a !== void 0 ? _a : [];
        const without = fns.filter((fn) => fn !== callback);
        this.callbacks[event] = without;
        return this;
    }
    emit(event, ...args) {
        var _a;
        const callbacks = (_a = this.callbacks[event]) !== null && _a !== void 0 ? _a : [];
        callbacks.forEach((callback) => {
            callback.apply(this, args);
        });
        return this;
    }
}
//# sourceMappingURL=emitter.js.map