import { Context } from "../../context";
import { Sync, Plugin, PluginDependencies } from "../plugin";
declare global {
    interface Window {
        gtag?: (...args: any[]) => void;
        JDataLayer?: any[];
    }
}
export declare class GA4Pixel implements Plugin {
    readonly name = "ga4_pixel";
    private browser;
    private readonly user;
    private readonly testingMode;
    private readonly enableHashing;
    private readonly logger;
    private settings;
    constructor(deps: PluginDependencies);
    identify(ctx: Context): Promise<Context>;
    track(ctx: Context): Context;
    page(ctx: Context): Context;
    group(ctx: Context): Context;
    updateSettings(sync: Sync): void;
    private trackPixelEvent;
    private callPixelHelper;
    private init;
    private loadScript;
}
