var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
/* eslint-disable  @typescript-eslint/no-explicit-any */
export function hashPII(obj = {}) {
    return __awaiter(this, void 0, void 0, function* () {
        const newObj = {};
        for (const key in obj) {
            let value = obj[key];
            if (value && PII_KEYS.has(key)) {
                value = (value + "").toLowerCase().trim();
                newObj[key] = yield sha256Hash(value);
            }
            else {
                newObj[key] = value;
            }
        }
        return newObj;
    });
}
function sha256Hash(input) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!input || isSHA256Hash(input)) {
            return input;
        }
        const encoder = new TextEncoder();
        const data = encoder.encode(input);
        const hashBuffer = yield crypto.subtle.digest("SHA-256", data);
        const hashArray = Array.from(new Uint8Array(hashBuffer));
        const hashHex = hashArray
            .map((b) => b.toString(16).padStart(2, "0"))
            .join("");
        return hashHex;
    });
}
function isSHA256Hash(input) {
    const sha256Regex = /^[a-f0-9]{64}$/i;
    return sha256Regex.test(input);
}
const PII_KEYS = new Set([
    "email",
    "phone",
    "name",
    "firstname",
    "lastname",
    "address",
    "city",
    "state",
    "city_code",
    "state_code",
    "country",
    "country_code",
    "gender",
]);
//# sourceMappingURL=hashPII.js.map