/* eslint-disable  @typescript-eslint/no-explicit-any */
export function applyTransformations(value, transformations) {
    let v = value;
    for (const transformation of transformations) {
        v = transformation(v);
    }
    return v;
}
export function toDigitsOnlyPhone(phone) {
    if (!phone) {
        return phone;
    }
    return phone.replace(/\D/g, "");
}
export function trim(str) {
    if (!str) {
        return str;
    }
    if (typeof str !== "string") {
        return str;
    }
    return str.trim() || null;
}
export function toLowerCase(str) {
    if (!str) {
        return str;
    }
    if (typeof str !== "string") {
        return str;
    }
    return str.toLowerCase() || null;
}
export function oneLetterGender(str) {
    if (!str) {
        return str;
    }
    return str.trim().charAt(0);
}
export function facebookBirthday(birthDate) {
    if (!birthDate) {
        return birthDate;
    }
    const date = new Date(birthDate);
    const year = date.getFullYear();
    const month = ("0" + (date.getMonth() + 1)).slice(-2); // Months are zero-based
    const day = ("0" + date.getDate()).slice(-2);
    return year.toString() + month.toString() + day.toString();
}
export function toInt(str) {
    const number = parseInt(str, 10);
    return isNaN(number) ? null : number;
}
//# sourceMappingURL=tranformations.js.map