import { Plugin, PluginDependencies, Sync } from "../plugin";
import { Context } from "../../context";
declare global {
    interface Window {
        pintrk?: {
            queue: any[];
            version: string;
        } & ((...args: any[]) => void);
    }
}
export declare class PinterestTag implements Plugin {
    readonly name = "pinterest_tag";
    private readonly browser;
    private readonly user;
    private readonly fieldMapperFactory;
    private readonly testingMode;
    private readonly logger;
    private settings;
    private fieldsMapper;
    private eventMapper;
    constructor(deps: PluginDependencies);
    identify(ctx: Context): Promise<Context> | Context;
    page(ctx: Context): Promise<Context> | Context;
    track(ctx: Context): Promise<Context> | Context;
    group(ctx: Context): Promise<Context> | Context;
    updateSettings(sync: Sync): void;
    private init;
    private loadScript;
    private initTag;
    private callPintrk;
    private trackTagEvent;
}
