import { Context } from "../../context";
import { PluginDependencies, Sync, Plugin } from "../plugin";
declare global {
    interface Window {
        TiktokAnalyticsObject?: string;
        ttq?: any;
    }
}
export declare class TikTokPixel implements Plugin {
    readonly name = "tiktok_pixel";
    private readonly browser;
    private readonly user;
    private readonly fieldMapperFactory;
    private readonly testingMode;
    private readonly logger;
    private settings;
    private fieldsMapper;
    private eventMapper;
    constructor(deps: PluginDependencies);
    identify(ctx: Context): Context;
    track(ctx: Context): Context;
    page(ctx: Context): Context;
    group(ctx: Context): Context;
    updateSettings(sync: Sync): void;
    private init;
    private mapUserData;
    private callPixelHelper;
    private trackPixelEvent;
    private loadTiktokPixel;
}
